<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode"
              v-model="filter.code"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Posisi</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Posisi"
              v-model="filter.name"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="getPositions(true)">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom card-stretch-fourth p-5 gutter-b">
      <div class="d-flex my-3 justify-content-start">
        <button
          class="btn btn-success btn-md"
          @click="showInputModal(null, 'Form Tambah Posisi')"
        >
          <i class="flaticon-add"></i> Tambah Posisi
        </button>
      </div>

      <div class="card-body p-0">
        <complete-table :loading="loading" :data="positions">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">Code</th>
              <th class="pl-7">Posisi</th>
              <th class="pl-7 text-center">Aksi</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(position, i) in positions">
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ position.code }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ position.name }}
                  </span>
                </td>

                <td class="pl-0 pt-8 text-center">
                  <a
                    class="btn btn-light-success font-weight-bolder font-size-sm"
                    @click="showInputModal(position, 'Form Ubah Posisi', false)"
                  >
                    <i class="flaticon-edit"></i>
                  </a>

                  <a
                    class="btn btn-light-danger font-weight-bolder font-size-sm ml-2"
                    @click="showDeleteModal(position)"
                  >
                    <i class="flaticon-delete"></i>
                  </a>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal ref="input" hide-footer :title="modalTitle">
      <div class="d-block text-center">
        <form>
          <div class="row">
            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Code *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Code"
                v-model="form.code"
                :disabled="!isCreate"
              ></b-form-input>
            </div>
            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Posisi *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Nama Posisi"
                v-model="form.name"
              ></b-form-input>
            </div>
          </div>
        </form>

        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            block
            @click="isCreate ? savePosition() : updatePosition()"
          >
            Simpan
          </b-button>

          <b-button
            :disabled="loading"
            class="btn btn-secondary mt-0"
            block
            @click="closeInputModal"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>

    <b-modal ref="delete" hide-footer title="Warning">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Posisi Akan Dihapus</label>
          </div>
        </div>
        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            @click="deletePosition"
            block
          >
            Hapus
          </b-button>

          <b-button
            class="btn btn-secondary mt-0"
            block
            @click="closeDeleteModal"
            :disabled="loading"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import {
  DELETE_POSITION,
  GET_POSITION,
  SAVE_POSITION,
  UPDATE_POSITION
} from "../../../core/services/store/position.module";

export default {
  components: { CompleteTable },

  data() {
    return {
      filter: {
        code: null,
        name: null
      },
      currentItem: null,
      modalTitle: null,
      form: {
        code: null,
        name: null
      },
      isCreate: true
    };
  },

  computed: {
    ...mapState({
      loading: state => state.position.loading,
      positions: state => state.position.positions?.data
    })
  },

  methods: {
    showInputModal(position, modalTitle, isCreate = true) {
      this.currentItem = position;

      this.form = {
        code: position?.code,
        name: position?.name
      };

      this.modalTitle = modalTitle;

      this.isCreate = isCreate;

      this.$refs["input"].show();
    },

    showDeleteModal(position) {
      this.currentItem = position;

      this.$refs["delete"].show();
    },

    closeInputModal() {
      this.$refs["input"].hide();
    },

    closeDeleteModal() {
      this.$refs["delete"].hide();
    },

    getPositions(filter = false) {
      if (!arrayMoreThanOne(this.positions) || filter) {
        this.$store.dispatch(GET_POSITION, {
          params: {}
        });
      }
    },

    deletePosition() {
      this.$store
        .dispatch(DELETE_POSITION, {
          code: this.currentItem?.code
        })
        .then(() => {
          this.closeDeleteModal();
        });
    },

    savePosition() {
      this.$store.dispatch(SAVE_POSITION, this.form).then(() => {
        this.closeInputModal();
      });
    },

    updatePosition() {
      this.$store.dispatch(UPDATE_POSITION, this.form).then(() => {
        this.closeInputModal();
      });
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Posisi" }]);

    this.getPositions();
  }
};
</script>
